aboutsummaryrefslogtreecommitdiff
path: root/herbstluftwm
diff options
context:
space:
mode:
authorxero <x@xero.nu>2014-07-14 13:23:05 -0400
committerxero <x@xero.nu>2014-07-14 13:23:05 -0400
commit56560fd597f94dfe6fe5fa79648398ab29d05775 (patch)
tree7e77d23be98b2df8ef847f49ee645085356305be /herbstluftwm
parent1434c859bcf94a0bbee88e72c8a01849d0356293 (diff)
downloaddotfiles_ascii-56560fd597f94dfe6fe5fa79648398ab29d05775.tar.xz
dotfiles_ascii-56560fd597f94dfe6fe5fa79648398ab29d05775.zip
updated repo to manage dotfiles via gnu stow, the symlink farm manager. happy birthday commit! :birthday: :sparkles:
Diffstat (limited to 'herbstluftwm')
-rwxr-xr-xherbstluftwm/.config/herbstluftwm/autostart187
-rwxr-xr-xherbstluftwm/.config/herbstluftwm/conkypanel24
-rwxr-xr-xherbstluftwm/.config/herbstluftwm/panel.sh267
-rw-r--r--herbstluftwm/.xinitrc75
-rw-r--r--herbstluftwm/.zprofile1
-rwxr-xr-xherbstluftwm/code/sys/herbstluftwm-add-gap9
-rwxr-xr-xherbstluftwm/code/sys/herbstluftwm-remove-gap11
-rw-r--r--herbstluftwm/preview.pngbin0 -> 98437 bytes
8 files changed, 574 insertions, 0 deletions
diff --git a/herbstluftwm/.config/herbstluftwm/autostart b/herbstluftwm/.config/herbstluftwm/autostart
new file mode 100755
index 0000000..db83e85
--- /dev/null
+++ b/herbstluftwm/.config/herbstluftwm/autostart
@@ -0,0 +1,187 @@
+#!/bin/bash
+#
+# ██ ██ ██ ██ ████ ██
+# ░██ ░██ ░██ ░██ ░██░ ░██
+# ░██ █████ ██████░██ ██████ ██████ ░██ ██ ██ ██████ ██████
+# ░██████ ██░░░██░░██░░█░██████ ██░░░░ ░░░██░ ░██░██ ░██░░░██░ ░░░██░
+# ░██░░░██░███████ ░██ ░ ░██░░░██░░█████ ░██ ░██░██ ░██ ░██ ░██
+# ░██ ░██░██░░░░ ░██ ░██ ░██ ░░░░░██ ░██ ░██░██ ░██ ░██ ░██
+# ░██ ░██░░██████░███ ░██████ ██████ ░░██ ███░░██████ ░██ ░░██
+# ░░ ░░ ░░░░░░ ░░░ ░░░░░ ░░░░░░ ░░ ░░░ ░░░░░░ ░░ ░░
+
+hc() {
+ herbstclient "$@"
+}
+
+hc emit_hook reload
+
+# solid background
+#xsetroot -solid '#5A8E3A'
+
+# remove all existing keybindings
+hc keyunbind --all
+
+# close tray if reloading
+killall stalonetray
+killall conky
+
+# gap counter
+echo 10 > /tmp/herbstluftwm-gap
+
+# keybindings
+Mod=Mod4
+Alt=Mod1
+
+# run menu
+hc keybind $Mod-w spawn dmenu_run -nb '#222222' -nf '#bcbcbc' -sb '#6A8C8C' -sf '#101010' -i -fn '-Gohu-GohuFont-Medium-R-Normal'
+hc keybind $Mod-r spawn dmenu_run -nb '#222222' -nf '#bcbcbc' -sb '#6A8C8C' -sf '#101010' -i -fn '-Gohu-GohuFont-Medium-R-Normal'
+# toggle touchpad
+hc keybind $Mod-m spawn bash /home/xero/code/sys/toggle-touchpad
+# dynamic window gap
+hc keybind $Mod-9 spawn bash /home/xero/code/sys/herbstluftwm-remove-gap
+hc keybind $Mod-0 spawn bash /home/xero/code/sys/herbstluftwm-add-gap
+
+hc keybind $Mod-Shift-q quit
+hc keybind $Mod-Shift-r reload
+hc keybind $Mod-Shift-c close
+hc keybind $Mod-Return spawn urxvtc
+
+# basic movement
+# focusing clients
+hc keybind $Mod-Left focus left
+hc keybind $Mod-Down focus down
+hc keybind $Mod-Up focus up
+hc keybind $Mod-Right focus right
+hc keybind $Mod-h focus left
+hc keybind $Mod-j focus down
+hc keybind $Mod-k focus up
+hc keybind $Mod-l focus right
+
+# moving clients
+hc keybind $Mod-Shift-Left shift left
+hc keybind $Mod-Shift-Down shift down
+hc keybind $Mod-Shift-Up shift up
+hc keybind $Mod-Shift-Right shift right
+hc keybind $Mod-Shift-h shift left
+hc keybind $Mod-Shift-j shift down
+hc keybind $Mod-Shift-k shift up
+hc keybind $Mod-Shift-l shift right
+
+# splitting frames
+# create an empty frame at the specified direction
+hc keybind $Mod-u split bottom 0.5 #row
+hc keybind $Mod-o split right 0.5 #column
+# let the current frame explode into subframes
+hc keybind $Mod-Control-space split explode
+
+# resizing frames
+resizestep=0.05
+hc keybind $Mod-Control-h resize left +$resizestep
+hc keybind $Mod-Control-j resize down +$resizestep
+hc keybind $Mod-Control-k resize up +$resizestep
+hc keybind $Mod-Control-l resize right +$resizestep
+hc keybind $Mod-Control-Left resize left +$resizestep
+hc keybind $Mod-Control-Down resize down +$resizestep
+hc keybind $Mod-Control-Up resize up +$resizestep
+hc keybind $Mod-Control-Right resize right +$resizestep
+
+
+# tags
+tag_names=( 0000 0001 0010 0011 0100 0101 0110 0111 1000 1001 )
+#tag_names=( {0..9} )
+
+# set up normal tags
+hc rename default "${tag_names[0]}" || true
+for i in ${!tag_names[@]} ; do
+ hc add "${tag_names[$i]}"
+done
+
+# cycle through tags
+hc keybind $Mod-$Alt-Left use_index -1 --skip-visible
+hc keybind $Mod-$Alt-Right use_index +1 --skip-visible
+
+# layouting
+hc keybind $Mod-x remove
+hc keybind $Mod-space cycle_layout 1
+hc keybind $Mod-Shift-space cycle_layout -1
+#hc keybind $Mod-s floating toggle
+hc keybind $Mod-f fullscreen toggle
+hc keybind $Mod-p pseudotile toggle
+
+# mouse
+hc mouseunbind --all
+hc mousebind $Mod-Button1 move
+hc mousebind $Mod-Button2 zoom
+hc mousebind $Mod-Button3 resize
+
+# focus
+hc keybind $Mod-BackSpace cycle_monitor
+hc keybind $Mod-Tab cycle_all +1
+hc keybind $Mod-Shift-Tab cycle_all -1
+hc keybind $Mod-n cycle
+hc keybind $Mod-i jumpto urgent
+
+
+# theme
+hc attr theme.tiling.reset 1
+hc attr theme.floating.reset 1
+hc set frame_border_active_color '#222222'
+hc set frame_border_normal_color '#222222'
+hc set frame_bg_normal_color '#000000'
+hc set frame_bg_active_color '#6A8C8C'
+hc set frame_border_width 0
+hc set always_show_frame 0
+hc set frame_bg_transparent 1
+hc set frame_transparent_width 0
+hc set frame_gap 8
+
+# hc attr theme.active.color '#222222'
+#hc attr theme.active.color '#666666'
+hc attr theme.active.color '#6A8C8C'
+hc attr theme.normal.color '#000000'
+hc attr theme.urgent.color '#6A8C8C'
+hc attr theme.inner_width 0
+hc attr theme.inner_color black
+hc attr theme.border_width 3
+hc attr theme.floating.border_width 3
+hc attr theme.floating.outer_width 1
+hc attr theme.floating.outer_color black
+hc attr theme.active.inner_color '#222222'
+hc attr theme.active.outer_color '#6A8C8C'
+hc attr theme.background_color '#141414'
+
+hc set window_gap 10
+hc set frame_padding 0
+hc set smart_window_surroundings 0
+hc set smart_frame_surroundings 1
+hc set mouse_recenter_gap 0
+
+# rules
+hc unrule -F
+#hc rule class=XTerm tag=3 # move all xterms to tag 3
+hc rule focus=on # normally focus new clients
+#hc rule focus=off # normally do not focus new clients
+# give focus to most common terminals
+#hc rule class~'(.*[Rr]xvt.*|.*[Tt]erm|Konsole)' focus=on
+hc rule windowtype~'_NET_WM_WINDOW_TYPE_(DIALOG|UTILITY|SPLASH)' pseudotile=on
+hc rule windowtype='_NET_WM_WINDOW_TYPE_DIALOG' focus=on
+hc rule windowtype~'_NET_WM_WINDOW_TYPE_(NOTIFICATION|DOCK|DESKTOP)' manage=off
+
+# unlock, just to be sure
+hc unlock
+
+herbstclient set tree_style '╾│ ├└╼─┐'
+
+# do multi monitor setup here, e.g.:
+# hc set_monitors 1280x1024+0+0 1280x1024+1280+0
+# or simply:
+# hc detect_monitors
+
+# find the panel
+#panel=~/.config/herbstluftwm/conkypanel
+panel=~/.config/herbstluftwm/panel.sh
+[ -x "$panel" ] || panel=/etc/xdg/herbstluftwm/panel.sh
+for monitor in $(herbstclient list_monitors | cut -d: -f1) ; do
+ # start it on each monitor
+ "$panel" $monitor &
+done
diff --git a/herbstluftwm/.config/herbstluftwm/conkypanel b/herbstluftwm/.config/herbstluftwm/conkypanel
new file mode 100755
index 0000000..2893da7
--- /dev/null
+++ b/herbstluftwm/.config/herbstluftwm/conkypanel
@@ -0,0 +1,24 @@
+#!/bin/bash
+hc() { "${herbstclient_command[@]:-herbstclient}" "$@" ;}
+monitor=${1:-0}
+geometry=( $(herbstclient monitor_rect "$monitor") )
+if [ -z "$geometry" ] ;then
+ echo "Invalid monitor $monitor"
+ exit 1
+fi
+# geometry has the format W H X Y
+x=${geometry[0]}
+y=${geometry[1]}
+panel_width=${geometry[2]}
+panel_height=16
+#font="-*-fixed-medium-*-*-*-12-*-*-*-*-*-*-*"
+font="-Gohu-GohuFont-Medium-R-Normal--11-80-100-100-C-60-ISO10646-1"
+bgcolor=$(hc get frame_border_normal_color)
+fgcolor='#efefef'
+
+conky | dzen2 -w $panel_width -x $x -y $y -fn "$font" -h $panel_height \
+ -e 'button3=;button4=exec:herbstclient use_index -1;button5=exec:herbstclient use_index +1' \
+ -ta l -bg "$bgcolor" -fg "$fgcolor" &
+
+sleep 2
+stalonetray
diff --git a/herbstluftwm/.config/herbstluftwm/panel.sh b/herbstluftwm/.config/herbstluftwm/panel.sh
new file mode 100755
index 0000000..9a8928b
--- /dev/null
+++ b/herbstluftwm/.config/herbstluftwm/panel.sh
@@ -0,0 +1,267 @@
+#!/bin/bash
+# ██ ████
+# ░██ █░░░░█
+# ░██ ██████ █████ ███████ ░░ ░█
+# ██████░░░░██ ██░░░██░░██░░░██ ███
+# ██░░░██ ██ ░███████ ░██ ░██ █░░
+# ░██ ░██ ██ ░██░░░░ ░██ ░██ █░
+# ░░██████ ██████░░██████ ███ ░██░██████
+# ░░░░░░ ░░░░░░ ░░░░░░ ░░░ ░░ ░░░░░░
+
+hc() { "${herbstclient_command[@]:-herbstclient}" "$@" ;}
+monitor=${1:-0}
+geometry=( $(herbstclient monitor_rect "$monitor") )
+if [ -z "$geometry" ] ;then
+ echo "Invalid monitor $monitor"
+ exit 1
+fi
+# geometry has the format W H X Y
+x=${geometry[0]}
+y=${geometry[1]}
+panel_width=${geometry[2]}
+panel_height=16
+#font="-*-fixed-medium-*-*-*-12-*-*-*-*-*-*-*"
+font="-Gohu-GohuFont-Medium-R-Normal--11-80-100-100-C-60-ISO10646-1"
+#font2="-misc-stlarch-medium-r-normal--10-100-75-75-c-80-iso10646-1"
+
+bgcolor=$(hc get frame_border_normal_color)
+selbg='#6A8C8C'
+selfg='#101010'
+
+####
+# Try to find textwidth binary.
+# In e.g. Ubuntu, this is named dzen2-textwidth.
+if which textwidth &> /dev/null ; then
+ textwidth="textwidth";
+elif which dzen2-textwidth &> /dev/null ; then
+ textwidth="dzen2-textwidth";
+else
+ echo "This script requires the textwidth tool of the dzen2 project."
+ exit 1
+fi
+####
+# true if we are using the svn version of dzen2
+# depending on version/distribution, this seems to have version strings like
+# "dzen-" or "dzen-x.x.x-svn"
+if dzen2 -v 2>&1 | head -n 1 | grep -q '^dzen-\([^,]*-svn\|\),'; then
+ dzen2_svn="true"
+else
+ dzen2_svn=""
+fi
+
+if awk -Wv 2>/dev/null | head -1 | grep -q '^mawk'; then
+ # mawk needs "-W interactive" to line-buffer stdout correctly
+ # http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=593504
+ uniq_linebuffered() {
+ awk -W interactive '$0 != l { print ; l=$0 ; fflush(); }' "$@"
+ }
+else
+ # other awk versions (e.g. gawk) issue a warning with "-W interactive", so
+ # we don't want to use it there.
+ uniq_linebuffered() {
+ awk '$0 != l { print ; l=$0 ; fflush(); }' "$@"
+ }
+fi
+
+hc pad $monitor $panel_height
+
+{
+ ### Event generator ###
+ # based on different input data (mpc, date, hlwm hooks, ...) this generates events, formed like this:
+ # <eventname>\t<data> [...]
+ # e.g.
+ # date ^fg(#efefef)18:33^fg(#909090), 2013-10-^fg(#efefef)29
+
+ #mpc idleloop player &
+ while true ; do
+ # "date" output is checked once a second, but an event is only
+ # generated if the output changed compared to the previous run.
+ date +$'date\t^bg(#666666) ^fg(#d9d9d9)^i(/usr/share/icons/stlarch_icons/clock1.xbm) ^fg(#efefef)%H:%M^fg(#bcbcbc) %Y-%m-^fg(#efefef)%d '
+ sleep 1 || break
+ done > >(uniq_linebuffered) &
+ childpid=$!
+ hc --idle
+ kill $childpid
+} 2> /dev/null | {
+ IFS=$'\t' read -ra tags <<< "$(hc tag_status $monitor)"
+ visible=true
+ date=""
+ windowtitle=""
+ while true ; do
+
+ ### Output ###
+ # This part prints dzen data based on the _previous_ data handling run,
+ # and then waits for the next event to happen.
+
+ bordercolor="#26221C"tags
+ separator=" "
+ xicon="#d9d9d9"
+ xtitle="#bcbcbc"
+ xfg="#ffffff"
+ xext="#909090"
+ cool="#6A8C8C"
+ hot="#990000"
+ # draw tags
+ for i in "${tags[@]}" ; do
+ case ${i:0:1} in
+ '#')
+ echo -n "^bg($selbg)^fg($selfg)"
+ ;;
+ '+')
+ echo -n "^bg(#9CA668)^fg(#141414)"
+ ;;
+ ':')
+ echo -n "^bg(#333333)^fg(#ffffff)"
+ ;;
+ '!')
+ echo -n "^bg(#FF0675)^fg(#141414)"
+ ;;
+ *)
+ echo -n "^bg(#111111)^fg($xtitle)"
+ ;;
+ esac
+ if [ ! -z "$dzen2_svn" ] ; then
+ # clickable tags if using SVN dzen
+ echo -n "^ca(1,\"${herbstclient_command[@]:-herbstclient}\" "
+ echo -n "focus_monitor \"$monitor\" && "
+ echo -n "\"${herbstclient_command[@]:-herbstclient}\" "
+ #echo -n "use \"${i:1}\") ^i(/usr/share/icons/stlarch_icons/diamond1.xbm) ^ca()"
+ echo -n "use \"${i:1}\") ${i:1} ^ca()"
+ else
+ # non-clickable tags if using older dzen
+ echo -n " ${i:1} "
+ fi
+ done
+ echo -n "$separator"
+ #echo -n "^bg()^fg() ${windowtitle//^/^^}"
+ temp=`sensors | awk '/Core\ 0/ {gsub(/\+/,"",$3); gsub(/\..+/,"",$3); print $3}'`
+ # temp heat colorizing
+ if (($temp<=50))
+ then
+ temp="^fg($cool)$temp"
+ elif (($temp>50 && $temp<=75))
+ then
+ temp="^fg($xfg)$temp"
+ elif (($temp>76))
+ then
+ temp="^fg($hot)$temp"
+ else
+ temp="^fg($xfg)$temp"
+ fi
+ temp="^fg($xicon)^i(/usr/share/icons/stlarch_icons/temp1.xbm) ^fg($xtitle)temp $temp^fg($xext)°c"
+ #up time
+ upSeconds=`cat /proc/uptime`;
+ upSeconds=${upSeconds%%.*};
+ let secs=$((${upSeconds}%60))
+ let mins=$((${upSeconds}/60%60))
+ let hours=$((${upSeconds}/3600%24))
+ let days=$((${upSeconds}/86400))
+ uptime="^fg($xicon)^i(/usr/share/icons/stlarch_icons/uparrow1.xbm) ^fg($xtitle)uptime ^fg($xfg)${days}^fg($xext)d ^fg($xfg)${hours}^fg($xext)h ^fg($xfg)${mins}^fg($xext)m"
+ #pacman updates
+ updates=`pacman -Quq | wc -l`
+ updates="^fg($xicon)^i(/usr/share/icons/stlarch_icons/pacman1.xbm) ^fg($xtitle)pacman ^fg($xfg)$updates"
+ #cpu
+ cpu=`mpstat | awk '$3 ~ /CPU/ { for(i=1;i<=NF;i++) { if ($i ~ /%idle/) field=i } } $3 ~ /all/ { print 100 - $field }'`
+ cpu="^fg($xicon)^i(/usr/share/icons/stlarch_icons/cpu1.xbm) ^fg($xtitle)cpu ^fg($xfg)$cpu^fg($xext)%"
+ #memory
+ mem=`free -om | awk '/Mem:/ {print int(($3 - $7 - $6) / $2 * 100)}'`
+ mem="^fg($xicon)^i(/usr/share/icons/stlarch_icons/mem1.xbm) ^fg($xtitle)ram ^fg($xfg)$mem^fg($xext)%"
+ #battery
+ bat=`cat /sys/class/power_supply/BAT1/capacity`
+ batstat=`cat /sys/class/power_supply/BAT1/status`
+ if (($batstat=='Charging'))
+ then
+ batico="^i(/usr/share/icons/stlarch_icons/ac10.xbm)"
+ else
+ batico="^i(/usr/share/icons/stlarch_icons/batt5full.xbm)"
+ fi
+ bat="^fg($xicon)$batico ^fg($xtitle)battery ^fg($xfg)$bat^fg($xext)%"
+ #cyberspace
+ # read lo int1 int2 <<< `ip link | sed -n 's/^[0-9]: \(.*\):.*$/\1/p'`
+ # if iwconfig $int1 >/dev/null 2>&1; then
+ # wifi=$int1
+ # eth0=$int2
+ # else
+ # wifi=$int2
+ # eth0=$int1
+ # fi
+ # ip link show $eth0 | grep 'state UP' >/dev/null && int=$eth0 || int=$wifi
+ # if (($int==$wifi))
+ # then
+ # net="^fg($xicon)^i(/usr/share/icons/stlarch_icons/wireless5.xbm) ^fg($xtitle)network ^fg($xfg)wifi"
+ # elif (($int==$eth0))
+ # then
+ # net="^fg($xicon)^i(/usr/share/icons/stlarch_icons/ac5.xbm) ^fg($xtitle)network ^fg($xfg)ethernet"
+ # else
+ # net="^fg($xicon)^i(/usr/share/icons/stlarch_icons/dice5.xbm) ^fg($xtitle)network ^fg($xfg)disconnected"
+ # fi
+ #combine
+ right="^bg(#333333) $cpu $separator $mem $separator $temp $separator $bat $separator $updates $separator $uptime ^bg(#444444) $date $separator $separator"
+
+ right_text_only=$(echo -n "$right" | sed 's.\^[^(]*([^)]*)..g')
+ # get width of right aligned text.. and add some space..
+ width=$($textwidth "$font" "$right_text_only ")
+ echo -n "^pa($(($panel_width - $width)))$right"
+ echo
+
+ ### Data handling ###
+ # This part handles the events generated in the event loop, and sets
+ # internal variables based on them. The event and its arguments are
+ # read into the array cmd, then action is taken depending on the event
+ # name.
+ # "Special" events (quit_panel/togglehidepanel/reload) are also handled
+ # here.
+
+ # wait for next event
+ IFS=$'\t' read -ra cmd || break
+ # find out event origin
+ case "${cmd[0]}" in
+ tag*)
+ #echo "resetting tags" >&2
+ IFS=$'\t' read -ra tags <<< "$(hc tag_status $monitor)"
+ ;;
+ date)
+ #echo "resetting date" >&2
+ date="${cmd[@]:1}"
+ ;;
+ quit_panel)
+ exit
+ ;;
+ togglehidepanel)
+ currentmonidx=$(hc list_monitors | sed -n '/\[FOCUS\]$/s/:.*//p')
+ if [ "${cmd[1]}" -ne "$monitor" ] ; then
+ continue
+ fi
+ if [ "${cmd[1]}" = "current" ] && [ "$currentmonidx" -ne "$monitor" ] ; then
+ continue
+ fi
+ echo "^togglehide()"
+ if $visible ; then
+ visible=false
+ hc pad $monitor 0
+ else
+ visible=true
+ hc pad $monitor $panel_height
+ fi
+ ;;
+ reload)
+ exit
+ ;;
+ focus_changed|window_title_changed)
+ windowtitle="${cmd[@]:2}"
+ ;;
+ #player)
+ # ;;
+ esac
+ done
+
+ ### dzen2 ###
+ # After the data is gathered and processed, the output of the previous block
+ # gets piped to dzen2.
+
+} 2> /dev/null | dzen2 -w $panel_width -x $x -y $y -fn "$font" -h $panel_height \
+ -e 'button3=;button4=exec:herbstclient use_index -1;button5=exec:herbstclient use_index +1' \
+ -ta l -bg "$bgcolor" -fg '#efefef' &
+
+sleep 2
+stalonetray
diff --git a/herbstluftwm/.xinitrc b/herbstluftwm/.xinitrc
new file mode 100644
index 0000000..2c96f83
--- /dev/null
+++ b/herbstluftwm/.xinitrc
@@ -0,0 +1,75 @@
+#!/bin/sh
+#
+# ██ ██ ██
+# ░░ ░░ ░██
+# ██ ██ ██ ███████ ██ ██████ ██████ █████
+# ░░██ ██ ░██░░██░░░██░██░░░██░ ░░██░░█ ██░░░██
+# ░░███ ░██ ░██ ░██░██ ░██ ░██ ░ ░██ ░░
+# ██░██ ░██ ░██ ░██░██ ░██ ░██ ░██ ██
+# ██ ░░██░██ ███ ░██░██ ░░██ ░███ ░░█████
+# ░░ ░░ ░░ ░░░ ░░ ░░ ░░ ░░░ ░░░░░
+#
+# ▓▓▓▓▓▓▓▓▓▓
+# ░▓ author ▓ xero <x@xero.nu>
+# ░▓ code ▓ http://code.xero.nu/dotfiles
+# ░▓ mirror ▓ http://git.io/.files
+# ░▓▓▓▓▓▓▓▓▓▓
+# ░░░░░░░░░░
+
+# merge custom x resources
+xrdb -merge "${HOME}/.Xdefaults" &
+
+# start the terminal emulator daemon
+urxvtd -q -f -o &
+
+# keyring
+gnome-keyring-daemon &
+
+# wifi
+/usr/lib/polkit-gnome/polkit-gnome-authentication-agent-1 &
+(sleep 2s && nm-applet --sm-disable) &
+
+# power management
+(sleep 2s && xfce4-power-manager) &
+
+# sound mixer
+(sleep 2s && pnmixer) &
+
+# volume keys daemon
+(sleep 2s && xfce4-volumed) &
+
+# compositing manager
+compton -b --config ~/.config/compton.conf &
+
+# start thunar daemon
+thunar --daemon &
+
+# wallpaper
+nitrogen --restore &
+
+# configure touchpad
+syndaemon -i 0.8 -d &
+if egrep -iq 'touchpad' /proc/bus/input/devices; then
+ synclient VertEdgeScroll=0 &
+ synclient TapButton1=1 &
+ synclient HorizTwoFingerScroll=1 &
+fi
+
+# clipboard manager
+(sleep 3s && clipit) &
+
+# keyboard settings - 250 ms delay and 25 cps (characters per second) repeat rate.
+xset r rate 250 25 &
+
+# disable system beep
+xset b off &
+
+# start the rock
+mpd &
+
+# setup fonts
+xset +fp ~/.fonts &
+xset fp rehash &
+
+# ░▒▓█ herbstluft █▓▒░
+exec herbstluftwm --locked
diff --git a/herbstluftwm/.zprofile b/herbstluftwm/.zprofile
new file mode 100644
index 0000000..3435b2c
--- /dev/null
+++ b/herbstluftwm/.zprofile
@@ -0,0 +1 @@
+[[ -z $DISPLAY && $XDG_VTNR -eq 1 ]] && startx
diff --git a/herbstluftwm/code/sys/herbstluftwm-add-gap b/herbstluftwm/code/sys/herbstluftwm-add-gap
new file mode 100755
index 0000000..08b5a03
--- /dev/null
+++ b/herbstluftwm/code/sys/herbstluftwm-add-gap
@@ -0,0 +1,9 @@
+#!/bin/bash
+filename="/tmp/herbstluftwm-gap"
+while read -r line
+do
+ gap=$line
+ gap=$((gap+10))
+ herbstclient set window_gap $gap
+ echo $gap > $filename
+done < "$filename"
diff --git a/herbstluftwm/code/sys/herbstluftwm-remove-gap b/herbstluftwm/code/sys/herbstluftwm-remove-gap
new file mode 100755
index 0000000..65c397a
--- /dev/null
+++ b/herbstluftwm/code/sys/herbstluftwm-remove-gap
@@ -0,0 +1,11 @@
+#!/bin/bash
+filename="/tmp/herbstluftwm-gap"
+while read -r line
+do
+ gap=$line
+ if [ "$gap" -ge 0 ]; then
+ gap=$((gap-10))
+ herbstclient set window_gap $gap
+ fi
+ echo $gap > $filename
+done < "$filename"
diff --git a/herbstluftwm/preview.png b/herbstluftwm/preview.png
new file mode 100644
index 0000000..76f23f9
--- /dev/null
+++ b/herbstluftwm/preview.png
Binary files differ